// Copyright
//
// This software is Copyright (c) 1994 - 2008, Engenic Communications Solutions Corporation
// http://www.engenic.com
//
//
// License
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
// Executable code that uses provided source code, or derivative works thereof, may
// only be used in conjunction with TeleFlow.
//
// Redistributions of source code must retain the above copyright notice, this list
// of conditions and the following disclaimer.
//
// Redistributions in binary form must reproduce the above copyright notice, this
// list of conditions and the following disclaimer in the documentation, about box
// and/or other materials provided with the distribution.
//
// No personal names or organizations names associated with Engenic may be used to
// endorse or promote products derived from this software without specific prior
// written permission of the specific individual or organization.
//
//
// THIS SOFTWARE IS PROVIDED BY ENGENIC "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
// OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
// GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
// OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#ifndef ENGLISH_CODE_H
#define ENGLISH_CODE_H

#include "LanguageModule.h"

class English : public LanguageModule
{
	public:

	   English(void);
   	~English(void);

   protected:

      WordList DateWordList(string date, LanguageModule::SAY_FORMAT format);
      WordList MoneyWordList(string money);
      WordList NumberGroupWordList(string numberGroup, bool ordinal);
      WordList NumberGroupWordList(int index, bool plural);
      WordList RealNumberWordList(string number);
      WordList TimeWordList(string time, LanguageModule::SAY_FORMAT format);

   protected:

      void InitialiseWordTable(void);
};

#endif