#ifndef IV_DBF_H
#define IV_DBF_H

#include "..\escutil\link.h"

// ----------------------------------------------------------------------------
typedef struct {
   unsigned char    dbf_id;
   char    last_update[3];
   unsigned long   last_rec;
   unsigned short  data_offset;
   unsigned short  rec_size;
   char    filler[20];
} DBF_HEAD;

// ----------------------------------------------------------------------------
typedef struct {
   char     name[11];
   char     type;               // 'C', 'D', 'L', 'M', 'M', 'N'
   char     dummy[4];
   union {
      unsigned short   char_len;
      struct {
         char     len;
         char     dec;
      } num_size;
   } len_info;
   char     filler[14];
} FIELD_REC;

// ----------------------------------------------------------------------------
class DBFField;

// ----------------------------------------------------------------------------
class DBFFile
{
   public:
      DBFFile();
      ~DBFFile();
      bool Open (const char *filename);
      void Close();
      bool Print();
      bool IsRecordDeleted();
      bool Fetch (unsigned long recNo);

// 	Not used anywhere
//    char* GetFieldName(char* fieldName, int fieldNo);

      char GetFieldType (int fieldNo);
      unsigned short GetFieldLength (int fieldNo);
      unsigned short GetFieldDecimal (int fieldNo);
		int GetFieldValueLength(int fieldNo);
      char* GetFieldValue(char* fieldValue, int fieldNo);
		int GetFieldValueLength(const char* fieldNm);
      char* GetFieldValue(char* fieldValue, const char* fieldNm);
      bool AddField (
         const char *   fieldNm,
         char           type,
         unsigned short len,
         unsigned short dec);

   private:
      Head *     fields;
      FILE *     fdb;
      DBF_HEAD   dbfHead;
      char *     pszRecord;

      bool Create (const char *filename);
      void SetDate();
      void ClearRecord();
      DBFField * FindField (int fieldNo);
      DBFField * FindField (const char *fieldNm);
};

#endif
