#include "..\inet\Socket.h"
#include "..\BoardDLLs\brd_generic.h"  // ProcessSystemEvent()
#include "step_UDPIPClose.h"

StepUDPIPClose::StepUDPIPClose(STEPREC& stepRecord) : Step(stepRecord)
{
   socketHandle = stepRecord.s1.arr;
}

StepUDPIPClose::~StepUDPIPClose(void)
{
}

const char* StepUDPIPClose::GetStepName(void) const
{
	return("UDP Close");
}

IV_STATUS StepUDPIPClose::Execute(PIVRINFO pInfo)
{
   char* value;
   UDPSocket socket;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Socket handle", socketHandle.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   socket.set_handle((ACE_HANDLE) atoi(value));
   delete[] value;

   socket.Close();

   return(IVR_SUCCESS);
}
 