#include <stdlib.h>               // atoi
#include "step_confclose.h"
#include "..\BoardDLLs\brd_generic.h"

StepConfClose::StepConfClose(STEPREC& stepRecord) : Step(stepRecord)
{
   handle = stepRecord.s1.arr;
}

StepConfClose::~StepConfClose(void)
{
}

const char* StepConfClose::GetStepName(void) const
{
	return("Close Conference");
}

// -------------------------------------------------------------------------
//   Name:        StepConfClose::Execute
//
//   Purpose:     "Close" an existing conference
//
//   Notes:       This function does not return IVR_FAIL if the conference
//                handle does not exist.  Closing a non-existent (perhaps
//                because it has already been closed) conference results in
//                success.
// -------------------------------------------------------------------------
IV_STATUS StepConfClose::Execute(PIVRINFO pInfo)
{
   int   iHandle;
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Handle", handle.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   iHandle = atoi(value);
   delete[] value;

   return(pInfo->ivBoard->ConfDestroy(iHandle));
}
