#pragma hdrstop
#include "..\escutil\security.h"
#include "..\BoardDLLs\brd_generic.h"
#include "step_hash.h"

StepHash::StepHash(STEPREC& stepRecord) : Step(stepRecord)
{
   resultVar = stepRecord.s2.arr;
   text = stepRecord.s1.arr;
   uppercase = (bool) stepRecord.u1;
}

StepHash::~StepHash(void)
{
}

const char* StepHash::GetStepName(void) const
{
	return("Hash");
}

IV_STATUS StepHash::Execute(PIVRINFO pInfo)
{
   char* value;
   char* pszHash;
   IV_STATUS status;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Text to hash", text.c_str(), "")) == NULL)
   {
      return(IVR_FATAL);
   }

   pszHash = MD5Hash(value, uppercase);
  	delete[] value;

   if(pszHash == NULL)
   {
   	pInfo->ivLog->Print("      ERROR: Invalid hash obtained for '%s'\n", text.c_str());
      return(IVR_FATAL);
   }

   status = pInfo->variables->Set(resultVar.c_str(), pszHash) ? IVR_SUCCESS : IVR_FATAL;

   delete[] pszHash;

   return(status);
 }
