#include <stdlib.h>             // Needed for "atoi".
#include "step_switch.h"
#include "..\BoardDLLs\brd_generic.h"

StepSwitch::StepSwitch(STEPREC& stepRecord) : Step(stepRecord)
{
   line2 = stepRecord.s2.arr;
   bListenOnly = (bool) stepRecord.u1;
}

StepSwitch::~StepSwitch(void)
{
}

const char* StepSwitch::GetStepName(void) const
{
    return("Switch Call");
}

IV_STATUS StepSwitch::Execute(PIVRINFO pInfo)
{
	int        iNewPort;
	IV_STATUS  status;
	char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if((value = pInfo->variables->ParseParameter("Port", line2.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   iNewPort = atoi(value);
   delete[] value;

   // Call board function to make the connection:
   // -------------------------------------------
   status = pInfo->ivBoard->Switch(iNewPort, bListenOnly);

	return(status);
}
