#include <stdlib.h>             // Needed for "atoi".

#include "step_transfercall.h"
#include "..\BoardDLLs\brd_generic.h"

StepTransferCall::StepTransferCall(STEPREC& stepRecord) : Step(stepRecord)
{
   otherCallRef = stepRecord.s1.arr;
}

StepTransferCall::~StepTransferCall(void)
{
}

const char* StepTransferCall::GetStepName(void) const
{
	return("Transfer Call");
}

IV_STATUS StepTransferCall::Execute(PIVRINFO pInfo)
{
   char* value;
   WORD wOtherCallRef = 0;
   IV_STATUS status;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if((value = pInfo->variables->ParseParameter("Call reference", otherCallRef.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   wOtherCallRef = (WORD) atoi(value);
   delete[] value;

   pInfo->ivLog->Print("      Transfer current call to other call reference %u\n", wOtherCallRef);

   // Currently using "two channel transfer"
	status = pInfo->ivBoard->TransferCall(wOtherCallRef);

   return(status);
}
// StepTransferCall::Execute
