#include "step_varrandom.h"
#include "..\escutil\random.h"

StepVarRandom::StepVarRandom(STEPREC& stepRecord) : Step(stepRecord)
{
   varNm = stepRecord.s1.arr;
   startNumber = stepRecord.s2.arr;
   endNumber = stepRecord.s3.arr;
   Randomize((unsigned int) this);
}

StepVarRandom::~StepVarRandom(void)
{
}

const char* StepVarRandom::GetStepName(void) const
{
	return("Random Number");
}

IV_STATUS StepVarRandom::Execute (PIVRINFO pInfo)
{
   char* value;
   // Evaluate all parameters before exiting
   bool bParmsValid = true;
   int        iStart;
   int        iEnd;
   char  szNumber[30];

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Minimum number", startNumber.c_str())) == NULL)
   {
      bParmsValid = false;
   }
   else
   {
      iStart = atoi(value);
      delete[] value;
   }

   if((value = pInfo->variables->ParseParameter("Maximum number", endNumber.c_str())) == NULL)
   {
      bParmsValid = false;
   }
   else
   {
      iEnd = atoi(value);
      delete[] value;
   }

   if(!bParmsValid)
   {
      return(IVR_FATAL);
   }

   sprintf(szNumber, "%d", Random(iEnd + 1 - iStart) + iStart);

   if(!pInfo->variables->Set(varNm.c_str(), szNumber))
   {
      pInfo->ivLog->Print("      ERROR: Variable set failed\n");
      return(IVR_FATAL);
   }

   return(IVR_SUCCESS);
}
