#ifndef STEP_XMLFETCH_H
#define STEP_XMLFETCH_H

#include "step.h"
#include "..\xmlutil\xmllist.h"

class StepXMLFetch : public Step
{
   public:

      enum FETCH_DIRECTION
      {
         FORWARD,
         BACKWARD
      };

      StepXMLFetch(STEPREC& stepRecord);
      virtual ~StepXMLFetch(void);

		const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

   protected:

      string handle;       // S01: TeleFlow handle number (1-9)
      string node;         // S02: Node to fetch
      string  valueVar;     // S03: Variable to capture node's value
      string  attributes;   // S04: Formatted attribute text
      XMLFetch::SCOPE iScope;    // U01: Scope of variables to create:
                              //        VARSET_DEFAULT, VARSET_PRIVATE, VARSET_GLOBAL
      StepXMLFetch::FETCH_DIRECTION iDirection;      // U02: Fetch direction:
                              //        0 (default) = FETCH_FORWARD, 1 = FETCH_BACKWARD
                              //        see defines in 'step_xmlfetch.h'
};

#endif
