//---------------------------------------------------------------------------

#ifndef linelist_mainH
#define linelist_mainH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>

#include "..\TFServer\ivr_defs.h"

// Registry key where TeleFlow Application List Builder settings are stored
#define TFLINELIST_REG_KEY  TELEFLOW_REG_KEY "\\TeleFlow Line List Editor"

enum columns { APP_NAME = 1,
					APP_FILE_NAME,
					APP_PROTOCOL,
					APP_RESTART_COUNT,
					APP_NO_LIMIT,
					APP_LOG_OUTPUT,
					APP_APPEND_FILE,
					APP_PORT,
               APP_P1,
					APP_P2,
					APP_P3,
					APP_P4,
					APP_P5,
					APP_P6,
					APP_P7,
					APP_P8,
					APP_P9 };

//---------------------------------------------------------------------------

class TFormLineList : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *mnuMain;
	TMenuItem *mnuFile;
	TMenuItem *mnuFileOpen;
	TMenuItem *mnuFileNew;
	TMenuItem *mnuFileSave;
	TMenuItem *mnuFileSaveAs;
	TMenuItem *mnuFileClose;
	TMenuItem *mnuFileExit;
	TMenuItem *mnuEdit;
	TMenuItem *mnuEditInsert;
	TMenuItem *mnuEditInsertBlank;
	TMenuItem *mnuEditDelete;
	TMenuItem *mnuEditCopy;
	TMenuItem *mnuEditPaste;
	TMenuItem *mnuEditReplicate;
	TMenuItem *mnuHelp;
	TMenuItem *mnuHelpAbout;
	TImageList *imgCheckBox;
	TOpenDialog *dlgOpen;
	TStringGrid *clipBoard;
	TPanel *PanelAppList;
	TStringGrid *gridAppList;
	TPopupMenu *popMenuEdit;
	TMenuItem *popMenuEditInsert;
	TMenuItem *popMenuEditInsertBlank;
	TMenuItem *popMenuEditDelete;
	TMenuItem *popMenuEditPaste;
	TMenuItem *popMenuEditReplicate;
	TMenuItem *popMenuEditCopy;
	TMenuItem *N1;
	TMenuItem *N2;
	TSaveDialog *dlgSave;
	TMenuItem *mnuEditCut;
	TMenuItem *popMenuEditCut;
	TComboBox *ComboBoxProtocol;
	TButton *ButtonSelectTAP;
	TComboBox *ComboBoxLogErrors;
	TPanel *CheckBoxAppendFilePanel;
	TCheckBox *CheckBoxAppendFileHead;
	TCheckBox *CheckBoxAppendFileTail;
	TCheckBox *CheckBoxAppendFile;
	TMenuItem *mnuTools;
	TMenuItem *mnuToolsRenumber;
	TMenuItem *mnuEditSelectRow;
	TStringGrid *fileHistory;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *mnuFileHistory1;
	TMenuItem *mnuFileHistory2;
	TMenuItem *mnuFileHistory3;
	TMenuItem *mnuFileHistory5;
	TMenuItem *mnuFileHistory4;
	TMenuItem *mnuFileHistory6;
	TBitBtn *BitBtnProtocol;
	TBitBtn *BitBtnLogErrors;
	TPanel *CheckBoxNoLimitPanel;
	TCheckBox *CheckBoxNoLimitHead;
	TCheckBox *CheckBoxNoLimitTail;
	TCheckBox *CheckBoxNoLimit;
   TMenuItem *LineListHelp1;
	void __fastcall mnuHelpAboutClick(TObject *Sender);
	void __fastcall ComboBoxProtocolChange(TObject *Sender);
	void __fastcall CheckBoxNoLimitClick(TObject *Sender);
	void __fastcall CheckBoxAppendFileClick(TObject *Sender);
	void __fastcall mnuFileOpenClick(TObject *Sender);
	void __fastcall mnuFileExitClick(TObject *Sender);
	void __fastcall mnuFileSaveClick(TObject *Sender);
	void __fastcall mnuFileCloseClick(TObject *Sender);
	void __fastcall mnuEditInsertBlankClick(TObject *Sender);
	void __fastcall mnuEditDeleteClick(TObject *Sender);
	void __fastcall mnuEditCopyClick(TObject *Sender);
	void __fastcall mnuEditPasteClick(TObject *Sender);
	void __fastcall mnuEditInsertClick(TObject *Sender);
	void __fastcall mnuFileNewClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall gridAppListMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall mnuEditReplicateClick(TObject *Sender);
	void __fastcall mnuFileSaveAsClick(TObject *Sender);
	void __fastcall mnuEditCutClick(TObject *Sender);
	void __fastcall ComboBoxLogErrorsChange(TObject *Sender);
	void __fastcall gridAppListDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
	void __fastcall gridAppListSetEditText(TObject *Sender, int ACol,
          int ARow, const AnsiString Value);
	void __fastcall gridAppListKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall CheckBoxAppendFileHeadKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall CheckBoxAppendFileTailKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall CheckBoxNoLimitEnter(TObject *Sender);
	void __fastcall CheckBoxAppendFileEnter(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall gridAppListSelectCell(TObject *Sender, int ACol, int ARow,
          bool &CanSelect);
	void __fastcall gridAppListExit(TObject *Sender);
	void __fastcall mnuEditClick(TObject *Sender);
	void __fastcall popMenuEditPopup(TObject *Sender);
	void __fastcall mnuToolsRenumberClick(TObject *Sender);
	void __fastcall mnuEditSelectRowClick(TObject *Sender);
	void __fastcall mnuFileClick(TObject *Sender);
	void __fastcall mnuFileHistory1Click(TObject *Sender);
	void __fastcall mnuFileHistory2Click(TObject *Sender);
	void __fastcall mnuFileHistory3Click(TObject *Sender);
	void __fastcall mnuFileHistory4Click(TObject *Sender);
	void __fastcall mnuFileHistory5Click(TObject *Sender);
	void __fastcall mnuFileHistory6Click(TObject *Sender);
	void __fastcall BitBtnProtocolEnter(TObject *Sender);
	void __fastcall BitBtnLogErrorsEnter(TObject *Sender);
	void __fastcall ComboBoxProtocolEnter(TObject *Sender);
	void __fastcall ComboBoxLogErrorsEnter(TObject *Sender);
	void __fastcall CheckBoxNoLimitHeadKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall CheckBoxNoLimitTailKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall CheckBoxNoLimitExit(TObject *Sender);
	void __fastcall CheckBoxAppendFileExit(TObject *Sender);
	void __fastcall gridAppListEnter(TObject *Sender);
   void __fastcall ButtonSelectTAPMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall LineListHelp1Click(TObject *Sender);

private:	// User declarations
	// Loads .TAL file pszFileNm into grid and returns true if successful
	bool __fastcall LoadTAL(char* pszFileNm);

   // Returns the version of pszFileNm with 1 as default and 0 for failure
	int __fastcall DetermineTALVersion(char *pszFileNm);

	// Saves the current grid info as a (currently version 4) .tal file pszFileNm
   // and returns true if successful
	bool __fastcall SaveTAL (char* pszFileNm);

	// Clears the contents of each row of the grid and then set the grid to 2 lines
	void __fastcall ClearGrid(void);

	// Sets the defaults in the current blank row and adds a new blank row to the
   // end of the grid
	void __fastcall EditBlankRow(void);

	// Inserts number new rows above row row in grid
	void __fastcall InsertRows(int row, int number);

	// Deletes number rows including row row in grid
	void __fastcall DeleteRows(int row, int number);

   /* Creates iterations copies of row row, incrementing the IVR_PORT field if it
   	contains a non-zero integer, and incrementing the APPLICATION_NAME if it
      ends in a number.  These copies will be added at the end if append is true
      and after row row if append is false.
   */
	void __fastcall ReplicateRows(int row, int iterations, bool append);

	// Sets all necessary variable and menus when opening/closing the editor
	void __fastcall EditorActive(bool enable);

	// Draws special graphics for special cells
	void __fastcall gridAppListDrawSpecialCell(int ACol, int ARow);

	/* Pops up a save changes dialog and then saves the grid to TALFileName and
   	returns true for Yes, does not save the grid to TALFileName and returns true
      for No, or does not save the grid to TALFileName and returns false if cancelled
   */
	bool __fastcall SaveChanges(void);

   // Returns true if the value in RestartCount is valid, otherwise focuses back
   // on RestartCount and returns false
	bool __fastcall ValidRestartCount(int ACol, int ARow);

   // Returns true if the value in AppName is valid, otherwise focuses back
   // on AppName and returns false
   bool __fastcall ValidAppName(int ACol, int ARow);

   // Loads window settings and file history from the registry
	void __fastcall ReadRegistry(void);

   // Saves window settings and file history to the registry
	void __fastcall WriteRegistry(void);

	// Pops up a save as dialog, sets TALFileName to the dialog file name and then
   // saves the grid to the dialog file name
	bool __fastcall SaveAs(void);

   // Put the TALFileName at the top of the history list and bubble it if it was
   // already there
	void __fastcall HistoryAdd(void);

   // Returns true if all cells in the grid contain valid values
	bool __fastcall ValidCells(void);

   // True if the grid has been changed
	bool fileChanged;

   // True if there is valid data in the clipboard
   bool validClipboard;

   // True if the user has changed the checkbox value it isn't changing from
   // looking at a new cell
   bool validEdit;

   // Last column we were in
   int editCol;

   // Last row we were in
   int editRow;

   // True if we just TABbed
   bool TABFlag;

   // The file name and path of the current .TAL file
   char* TALFileName;

public:		// User declarations
	__fastcall TFormLineList(TComponent* Owner);
	__fastcall ~TFormLineList(void);
};
//---------------------------------------------------------------------------

extern PACKAGE TFormLineList *FormLineList;
//---------------------------------------------------------------------------
#endif
