// ----------------------------------------------------------------------------
// TeleFlow Open Server
//
// Copyright (C) 2008 engenic (engenic.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------

#include "license_read.h"

#ifdef TF_CLOSED_SOURCE
#include "..\tflicensing\LoadLicense.h"
#endif

TFLICENSESTRUCT ReadLicense(FileLog* ivLog)
{
   TFLICENSESTRUCT currentLicense;

#ifdef TF_CLOSED_SOURCE
   LICENSE_INFO tfLicense;    // TeleFlow License object
   // (Note: Constructor will populate license information from Registry)

   currentLicense.licensetype = tfLicense.GetLicenseStatus();
   currentLicense.numports = tfLicense.GetNumPorts();
   currentLicense.numdays = tfLicense.GetNumDays();
#else
   currentLicense.licensetype = GPL;
   currentLicense.numports = INT_MAX;
   currentLicense.numdays = 0;
#endif

   // Output messages to log if ivLog parameter supplied
   if(ivLog != NULL)
   {
      switch (currentLicense.licensetype)
      {
         case TEMPORARY:
         {
            ivLog->Print("This installation of Teleflow is licensed for %i ports.\n",
                         currentLicense.numports);
            ivLog->Print("This is an temporary licensed version of Teleflow.\n");
            ivLog->Print("There are %i days left on your license before this product reverts to an evaluation version.\n",
                         currentLicense.numdays);
            break;
         }

         case LICENSED:
         {
            ivLog->Print("This installation of Teleflow is licensed for %i ports.\n",
                         currentLicense.numports);
            break;
         }

         case GPL:
         {
            ivLog->Print("This installation of Teleflow is licensed under the GPL version 2.0\n");
            break;
         }

         case UNLICENSED:
         default:
         {
            ivLog->Print("This is an unlicensed or evaluation version of Teleflow.\n");
         }
      }
   }

   return(currentLicense);
}
