// ----------------------------------------------------------------------------
// TeleFlow Open Server
//
// Copyright (C) 2008 engenic (engenic.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
// http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Must be included before vcl.h
#include "TFSimulator_main.h"

#include <vcl.h>
#pragma hdrstop

USEFORM("msg_win.cpp", MsgWindow);
USEFORM("TFSimulator_about.cpp", AboutBox);
USEFORM("TFSimulator_logdir.cpp", LogDirForm);
USEFORM("TFSimulator_logsize.cpp", LogSizeForm);
USEFORM("TFSimulator_main.cpp", FormSimulator);
USEFORM("TFSimulator_placecall.cpp", PlaceCallForm);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
   try
   {
       Application->Initialize();
       Application->Title = "TeleFlow Simulator";
       Application->CreateForm(__classid(TFormSimulator), &FormSimulator);
       Application->CreateForm(__classid(TAboutBox), &AboutBox);
       Application->CreateForm(__classid(TLogDirForm), &LogDirForm);
       Application->CreateForm(__classid(TLogSizeForm), &LogSizeForm);
       Application->CreateForm(__classid(TMsgWindow), &MsgWindow);
       Application->CreateForm(__classid(TPlaceCallForm), &PlaceCallForm);
       FormSimulator->Setup();
       Application->Run();
       FormSimulator->Cleanup();
   }
   catch (Exception &exception)
   {
       Application->ShowException(&exception);
   }
   return 0;
}
//---------------------------------------------------------------------------
