/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
#include <windows.h>
#include <string>
using std::string;

#include "help_fns.h"

/* -------------------------------------------------------------------------
   Name:        HelpLink

   Purpose:     Opens TeleFlow help file to the requested topic,
                as passed in by pszTopicLink.
   ------------------------------------------------------------------------- */
bool HelpLink (const char *pszTopicLink)
{
   string helpcmd;

   char *pszCommand;
   STARTUPINFO startinf;
   PROCESS_INFORMATION procinf;

   if(pszTopicLink != NULL)
   {
      helpcmd = "hh teleflow.chm::/";
      helpcmd += pszTopicLink;

      // set parameters according to how Vern does it in TFDesigner
      memset((void*)&startinf, 0, sizeof(STARTUPINFO));
      startinf.cb = sizeof(STARTUPINFO);
      startinf.dwFlags = STARTF_USESHOWWINDOW;  // Hides Cmd wins
      startinf.wShowWindow = SW_SHOW;

      // set parameters according to how Vern does it in TFDesigner
      memset((void*)&procinf, 0, sizeof(PROCESS_INFORMATION));

      pszCommand = new char[helpcmd.length()+1];
      strcpy(pszCommand,helpcmd.c_str());

      CreateProcess(NULL,                      // LPCTSTR lpApplicationName,
                    pszCommand,                // LPTSTR lpCommandLine,
                    NULL,                      // LPSECURITY_ATTRIBUTES lpProcessAttributes,
                    NULL,                      // LPSECURITY_ATTRIBUTES lpThreadAttributes,
                    false,                     // BOOL bInheritHandles,
                    CREATE_DEFAULT_ERROR_MODE, // DWORD dwCreationFlags,
                    NULL,                      // LPVOID lpEnvironment,
                    NULL,                      // LPCTSTR lpCurrentDirectory,
                    &startinf,                 // LPSTARTUPINFO lpStartupInfo,
                    &procinf);                 // LPPROCESS_INFORMATION lpProcessInformation

      delete[] pszCommand;
      return(true);
   }
   return(false);
}
//HelpLink
