#ifndef SECURITY_H
#define SECURITY_H

#if defined (__DLL__)
#define SECURITY_API __declspec(dllexport)
#else
#define SECURITY_API __declspec(dllimport)
#endif

enum BLOWFISH_PADDING { PKCS_5_PADDING, ONES_AND_ZEROES_PADDING, NULL_PADDING, SPACE_PADDING };

SECURITY_API char* MD5Hash(const char* plainText, bool uppercase = true);
SECURITY_API char* Encrypt(const char* plainText, const char* encryptionKey,
   BLOWFISH_PADDING padding = PKCS_5_PADDING, bool uppercase = true);
SECURITY_API char* Decrypt(const char* encryptedText, const char* decryptionKey);

#undef SECURITY_API

#endif
